include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

stack equ <dword ptr [esp]>	; MasmBasic equate

FpuSave MACRO numregs:=<2>	; MasmBasic macro ( http://www.masm32.com/board/index.php?topic=12460 )
LOCAL ct
  FpuSaveRegs=numregs
  FpuSaveSize=16
  sub esp, FpuSaveSize*FpuSaveRegs
  ct=0
  REPEAT FpuSaveRegs
	@CatStr(<fxch st(>, %(7-ct), <)>)
	fstp REAL10 ptr [esp+ct*FpuSaveSize]
	@CatStr(<fld st(>, %(6-ct), <)>)
	@CatStr(<ffree st(>, %(7-ct), <)>)
	ct=ct+1
  ENDM
  nop
ENDM
FpuRestore MACRO
LOCAL ct
  ct=0
  REPEAT FpuSaveRegs
	fld REAL10 ptr [esp+ct*FpuSaveSize]
	ct=ct+1
  ENDM
  REPEAT FpuSaveRegs
	fincstp
  ENDM
  add esp, FpuSaveSize*FpuSaveRegs
ENDM
FillFPU MACRO
  finit
  push 1007
  REPEAT 8
	fild stack
	dec stack
  ENDM
ENDM

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	100	; test if anything changes when changing this
	LOOP_COUNT =	500000	; One Mio would be a typical value
	REPEAT 5
		invoke Sleep, SleepMs
		FillFPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			sub esp, 108
			fsave [esp]	; the traditional way
			nop
			frstor [esp]
			add esp, 108
		counter_end
		print str$(eax), 9, "cycles for fsave/frstor", 13, 10
		invoke Sleep, SleepMs
		FillFPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			FpuSave 4
			nop
			FpuRestore
		counter_end
		print str$(eax), 9, "cycles for FpuSave 4", 13, 10
		invoke Sleep, SleepMs
		FillFPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			FpuSave 3
			nop
			FpuRestore
		counter_end
		print str$(eax), 9, "cycles for FpuSave 3", 13, 10
		invoke Sleep, SleepMs
		FillFPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			FpuSave 2
			nop
			FpuRestore
		counter_end
		print str$(eax), 9, "cycles for FpuSave 2", 13, 10
		invoke Sleep, SleepMs
		FillFPU
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			FpuSave 1
			nop
			FpuRestore
		counter_end
		print str$(eax), 9, "cycles for FpuSave 1", 13, 10
		print chr$(13, 10)
	ENDM
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
1182    cycles for fsave/frstor
81      cycles for FpuSave 4
59      cycles for FpuSave 3
39      cycles for FpuSave 2
32      cycles for FpuSave 1

1114    cycles for fsave/frstor
115     cycles for FpuSave 4
59      cycles for FpuSave 3
110     cycles for FpuSave 2
32      cycles for FpuSave 1

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]